/*  Motor.h - Library für Schrittmotoren.
    Created by Henry, 01.08.2014.
    Not Released.  */

#include "Arduino.h"
#include "Motor.h"


Motor::Motor(int pinDIR, int pinSTEP) {
  dirPin = pinDIR;
  stepPin = pinSTEP;
}

void Motor::set_Direction(int dir) {
  if (dir == 1)
    digitalWrite(dirPin, HIGH);
  else
    digitalWrite(dirPin, LOW);
}

void Motor::makeStep() {
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(2);
    digitalWrite(stepPin,LOW);
}

void Motor::startUp(int dir, float steps, float t){

  stepsDone = 0;
  stepsToDo = steps;
  timeFrame = t;
  intervall = timeFrame/stepsToDo;
  
  if (dir == 1){
    digitalWrite(dirPin, HIGH);
  }  
  else {
    digitalWrite(dirPin, LOW);
  }  
  
  currentMillis = 0;
  previousMillis = 0;

}

void Motor::makeSteps() {

  currentMillis = millis();
  
  if((stepsToDo > stepsDone) && ((currentMillis - previousMillis) >= intervall)){
    // Fehler in der Praezision -> 
    makeStep();
    stepsDone++;
    previousMillis = currentMillis;
  }
}  
